#ifndef MDD_IMODULE_H
#define MDD_IMODULE_H

#include "IOutput.h"
#include <string>
#include <vector>
#include <memory>

namespace mdd {
    class IOutput;

    class IModule {
    public:
        virtual bool connectInput(int handle, std::shared_ptr<IOutput> output) = 0;

        virtual std::vector<std::string> getInputs() = 0;

        virtual std::vector<std::string> getOutputs() = 0;

        virtual std::shared_ptr<IOutput> getOutput(int handle) = 0;

        virtual void update() = 0;

        virtual ~IModule() = default;
    };
}
#endif //MDD_IMODULE_H
